CheckPassword checkPasswordFromJson(dynamic str) =>
    (CheckPassword.fromJson(str));

class CheckPassword {
  late final String sId;
  late final String password;
  late final String sTypename;

  CheckPassword(
      {required this.sId, required this.password, required this.sTypename});

  CheckPassword.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    password = json['password'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['password'] = this.password;
    data['__typename'] = this.sTypename;
    return data;
  }
}

CheckMobileAndEmail checkMobileEmailFromJson(dynamic str) =>
    (CheckMobileAndEmail.fromJson(str));

class CheckMobileAndEmail {
  late final bool? isMobile;
  late final bool? isEmail;

  CheckMobileAndEmail({required this.isMobile, required this.isEmail});

  CheckMobileAndEmail.fromJson(Map<String, dynamic> json) {
    isMobile = json['isMobile'];
    isEmail = json['isEmail'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['isMobile'] = this.isMobile;
    data['isEmail'] = this.isEmail;
    return data;
  }
}

AuthEmailOtpInput authEmailOtpInputFromJson(dynamic str) =>
    (AuthEmailOtpInput.fromJson(str));

class AuthEmailOtpInput {
  late final String? emailId;

  AuthEmailOtpInput({required this.emailId});

  AuthEmailOtpInput.fromJson(Map<String, dynamic> json) {
    emailId = json['emailId'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['emailId'] = this.emailId;
    return data;
  }
}
