class CartModel {}

ServerCartCount cartCountFromJson(dynamic str) =>
    (ServerCartCount.fromJson(str));

class ServerCartCount {
  late final int noOfProducts;

  ServerCartCount({required this.noOfProducts});

  ServerCartCount.fromJson(Map<String, dynamic> json) {
    noOfProducts = json["noOfProducts"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['noOfProducts'] = this.noOfProducts;
    return data;
  }
}

List<Cart> cartListFromJson(dynamic str) =>
    List<Cart>.from(str.map((x) => Cart.fromJson(x)));

Cart cartFromJson(dynamic str) => (Cart.fromJson(str));

class Cart {
  late final String sId;
  late final String packName;
  late final String packId;
  late final String? packImage;
  late final String? packSku;
  late final String? setId;
  late final int? quantity;
  late final int? piece;
  late final int? setPrice;
  late final int? price;
  late final String? variant;
  late final double? igst;
  late final double? cgst;
  late final double? sgst;
  late final String? variantValue;
  late final bool? isOutofstock;
  late final int? maximumQuantity;
  late final String sTypename;

  Cart(
      {required this.sId,
      required this.packName,
      required this.packId,
      required this.packImage,
      required this.packSku,
      required this.setId,
      required this.quantity,
      required this.piece,
      required this.setPrice,
      required this.price,
      required this.variant,
      required this.igst,
      required this.cgst,
      required this.sgst,
      required this.variantValue,
      required this.isOutofstock,
      required this.maximumQuantity,
      required this.sTypename});

  Cart.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    packName = json['packName'];
    packId = json['packId'];
    packImage = json['packImage'];
    packSku = json['packSku'];
    setId = json['setId'];
    quantity = json['quantity'];
    piece = json['piece'];
    setPrice = json['setPrice'];
    price = json['price'];
    variant = json['variant'];
    igst = json['igst'];
    cgst = json['cgst'];
    sgst = json['sgst'];
    variantValue = json['variantValue'];
    isOutofstock = json['isOutofstock'];
    maximumQuantity = json['maximumQuantity'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['packName'] = this.packName;
    data['packId'] = this.packId;
    data['packImage'] = this.packImage;
    data['packSku'] = this.packSku;
    data['setId'] = this.setId;
    data['quantity'] = this.quantity;
    data['piece'] = this.piece;
    data['setPrice'] = this.setPrice;
    data['price'] = this.price;
    data['variant'] = this.variant;
    data['igst'] = this.igst;
    data['cgst'] = this.cgst;
    data['sgst'] = this.sgst;
    data['variantValue'] = this.variantValue;
    data['isOutofstock'] = this.isOutofstock;
    data['maximumQuantity'] = this.maximumQuantity;
    data['__typename'] = this.sTypename;
    return data;
  }
}

RemoveCart removeCartFromJson(dynamic str) => (RemoveCart.fromJson(str));

class RemoveCart {
  late final int removeCart;

  RemoveCart({required this.removeCart});

  RemoveCart.fromJson(Map<String, dynamic> json) {
    removeCart = json['removeCart'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['removeCart'] = this.removeCart;
    return data;
  }
}

class UpdateCartRequest {
  late final String id;
  late final CartRequest cart;

  UpdateCartRequest({required this.id, required this.cart});
}

class CartRequest {
  late final int quantity;

  CartRequest({
    required this.quantity,
  });

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['quantity'] = this.quantity;
    return data;
  }
}

class AddCartRequest {
  late final String packId;
  late final int quantity;
  late final String setId;
  late final String userId;

  AddCartRequest(
      {required this.packId,
      required this.quantity,
      required this.setId,
      required this.userId});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['packId'] = this.packId;
    data['quantity'] = this.quantity;
    data['setId'] = this.setId;
    data['userId'] = this.userId;
    return data;
  }
}

class AddToCartRequest {
  late final String productId;
  late final int qty;
  late final String skuId;
  late final String userId;
  late final String type;
  late final bool isMultiple;
  late final bool? isCustomizable;
  late final List<dynamic>? skus;

  AddToCartRequest(
      {required this.productId,
      required this.qty,
      required this.skuId,
      required this.userId,
      required this.type,
      required this.isMultiple,
      this.isCustomizable,
      this.skus});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['productId'] = this.productId;
    data['qty'] = this.qty;
    data['skuId'] = this.skuId;
    data['userId'] = this.userId;
    data['type'] = this.type;
    data['isMultiple'] = this.isMultiple;
    data['isCustomizable'] = this.isCustomizable;
    data['skus'] = this.skus;
    return data;
  }
}

AddCart addCartFromJson(dynamic str) => (AddCart.fromJson(str));

class AddCart {
  late final int addCart;

  AddCart({required this.addCart});

  AddCart.fromJson(Map<String, dynamic> json) {
    addCart = json['addCart'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['addCart'] = this.addCart;
    return data;
  }
}

DelhiveryShippingFees delhiveryShippingFeesFromJson(dynamic str) =>
    (DelhiveryShippingFees.fromJson(str));

class DelhiveryShippingFees {
  late final double fees;
  late final double shippingIGST;
  late final double shippingSGST;
  late final double shippingCGST;
  late final String sTypename;

  DelhiveryShippingFees(
      {required this.fees,
      required this.shippingIGST,
      required this.shippingSGST,
      required this.shippingCGST,
      required this.sTypename});

  DelhiveryShippingFees.fromJson(Map<String, dynamic> json) {
    fees = json['fees'] == 0 ? json['fees'].toDouble() : json['fees'];
    shippingIGST = json['shippingIGST'] == 0
        ? json['shippingIGST'].toDouble()
        : json['shippingIGST'];
    shippingSGST = json['shippingSGST'] == 0
        ? json['shippingSGST'].toDouble()
        : json['shippingSGST'];
    shippingCGST = json['shippingCGST'] == 0
        ? json['shippingCGST'].toDouble()
        : json['shippingCGST'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['fees'] = this.fees;
    data['shippingIGST'] = this.shippingIGST;
    data['shippingSGST'] = this.shippingSGST;
    data['shippingCGST'] = this.shippingCGST;
    data['__typename'] = this.sTypename;
    return data;
  }
}

CheckCODForCheckout checkCODForCheckoutFromJson(dynamic str) =>
    (CheckCODForCheckout.fromJson(str));

class CheckCODForCheckout {
  late final bool? cod;
  late final int? charges;
  late final String sTypename;

  CheckCODForCheckout(
      {required this.cod, required this.charges, required this.sTypename});

  CheckCODForCheckout.fromJson(Map<String, dynamic> json) {
    cod = json['cod'];
    charges = json['charges'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['cod'] = this.cod;
    data['charges'] = this.charges;
    data['__typename'] = this.sTypename;
    return data;
  }
}

List<EnabledcheckoutOptions> enabledcheckoutOptionsFromJson(dynamic str) =>
    List<EnabledcheckoutOptions>.from(
        str.map((x) => EnabledcheckoutOptions.fromJson(x)));

class EnabledcheckoutOptions {
  late final String sId;
  late final String? gatewayName;
  late final String? type;
  late final String? code;
  late final String? description;
  late final bool? enable;
  late final List<Bank>? bank;
  late final String sTypename;

  EnabledcheckoutOptions(
      {required this.sId,
      required this.gatewayName,
      required this.type,
      required this.code,
      required this.description,
      required this.enable,
      required this.bank,
      required this.sTypename});

  EnabledcheckoutOptions.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    gatewayName = json['gatewayName'];
    type = json['type'];
    code = json['code'];
    description = json['description'];
    enable = json['enable'];
    if (json['list'] != null) {
      bank = [];
      json['list'].forEach((v) {
        bank!.add(new Bank.fromJson(v));
      });
    }
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['gatewayName'] = this.gatewayName;
    data['type'] = this.type;
    data['code'] = this.code;
    data['description'] = this.description;
    data['enable'] = this.enable;
    if (this.bank != null) {
      data['list'] = this.bank!.map((v) => v.toJson()).toList();
    }
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Bank {
  late final String sId;
  late final String? name;
  late final String? code;
  late final String? logo;
  late final bool? isPreview;
  late final String sTypename;

  Bank(
      {required this.sId,
      required this.name,
      required this.code,
      required this.logo,
      required this.isPreview,
      required this.sTypename});

  Bank.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    name = json['name'];
    code = json['code'];
    logo = json['logo'];
    isPreview = json['isPreview'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['name'] = this.name;
    data['code'] = this.code;
    data['logo'] = this.logo;
    data['isPreview'] = this.isPreview;
    data['__typename'] = this.sTypename;
    return data;
  }
}

DelhiveryServiceability delhiveryServiceabilityFromJson(dynamic str) =>
    (DelhiveryServiceability.fromJson(str));

class DelhiveryServiceability {
  late final bool? prePaid;
  late final bool? cash;
  late final bool? pickup;
  late final bool? cod;
  late final String? estimate;
  late final String sTypename;

  DelhiveryServiceability(
      {required this.prePaid,
      required this.cash,
      required this.pickup,
      required this.cod,
      required this.estimate,
      required this.sTypename});

  DelhiveryServiceability.fromJson(Map<String, dynamic> json) {
    prePaid = json['pre_paid'];
    cash = json['cash'];
    pickup = json['pickup'];
    cod = json['cod'];
    estimate = json['estimate'];
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['pre_paid'] = this.prePaid;
    data['cash'] = this.cash;
    data['pickup'] = this.pickup;
    data['cod'] = this.cod;
    data['estimate'] = this.estimate;
    data['__typename'] = this.sTypename;
    return data;
  }
}

CartForUser cartForUserFromJson(dynamic str) => (CartForUser.fromJson(str));

class CartForUser {
  late final TotalCartPrice? totalCartPrice;
  late final List<Products>? products;
  late final String? sTypename;

  CartForUser(
      {required this.totalCartPrice,
      required this.products,
      required this.sTypename});

  CartForUser.fromJson(Map<String, dynamic> json) {
    totalCartPrice = json['totalCartPrice'] != null
        ? new TotalCartPrice.fromJson(json['totalCartPrice'])
        : null;
    if (json['products'] != null) {
      products = <Products>[];
      json['products'].forEach((v) {
        products!.add(new Products.fromJson(v));
      });
    }
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.totalCartPrice != null) {
      data['totalCartPrice'] = this.totalCartPrice!.toJson();
    }
    if (this.products != null) {
      data['products'] = this.products!.map((v) => v.toJson()).toList();
    }
    data['__typename'] = this.sTypename;
    return data;
  }
}

class TotalCartPrice {
  late final double? totalWeight;
  late final int? cartCount;
  late final double? totalPrice;
  late final double? totalGstPrice;
  late final double? totalWithOutGstPrice;
  late final double? totalWithOutSCGstPrice;
  late final double? totalMrp;
  late final String? sTypename;

  TotalCartPrice(
      {required this.totalWeight,
      required this.cartCount,
      required this.totalPrice,
      required this.totalGstPrice,
      required this.totalWithOutGstPrice,
      required this.totalWithOutSCGstPrice,
      required this.totalMrp,
      required this.sTypename});

  TotalCartPrice.fromJson(Map<String, dynamic> json) {
    totalWeight = makeDouble(json['totalWeight']);
    cartCount = json['cartCount'];
    totalPrice = makeDouble(json['totalPrice']);
    totalGstPrice = makeDouble(json['totalGstPrice']);
    totalWithOutGstPrice = makeDouble(json['totalWithOutGstPrice']);
    totalWithOutSCGstPrice = makeDouble(json['totalWithOutSCGstPrice']);
    totalMrp = makeDouble(json['totalMrp']);
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['totalWeight'] = this.totalWeight;
    data['cartCount'] = this.cartCount;
    data['totalPrice'] = this.totalPrice;
    data['totalGstPrice'] = this.totalGstPrice;
    data['totalWithOutGstPrice'] = this.totalWithOutGstPrice;
    data['totalWithOutSCGstPrice'] = this.totalWithOutSCGstPrice;
    data['totalMrp'] = this.totalMrp;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Products {
  late final String? sId;
  late final String? code;
  late final String? productName;
  late final String? productId;
  late final String? imageId;
  late final String? skuId;
  late final String? productDescription;
  late final String? type;
  late final bool? isMultiple;
  late final List<Category>? category;
  late final List<Brand>? brand;
  late final List<Attribute>? attribute;
  late final Price? price;
  late final int? totalPieces;
  late final int? qty;
  late final String? imageUrl;
  late final List<SkuIds>? skuIds;
  late final List<SkuIds>? children;
  late final String? sTypename;

  Products(
      {required this.sId,
      required this.code,
      required this.productName,
      required this.productId,
      required this.imageId,
      required this.skuId,
      required this.productDescription,
      required this.type,
      required this.isMultiple,
      required this.category,
      required this.brand,
      required this.attribute,
      required this.price,
      required this.totalPieces,
      required this.qty,
      required this.imageUrl,
      required this.skuIds,
      required this.children,
      required this.sTypename});

  Products.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    code = json['code'];
    productName = json['productName'];
    productId = json['productId'];
    imageId = json['imageId'];
    skuId = json['skuId'];
    productDescription = json['productDescription'];
    type = json['type'];
    isMultiple = json['isMultiple'];
    category = <Category>[];
    if (json['category'] != null) {
      json['category'].forEach((v) {
        category!.add(new Category.fromJson(v));
      });
    }
    brand = <Brand>[];
    if (json['brand'] != null) {
      json['brand'].forEach((v) {
        brand!.add(new Brand.fromJson(v));
      });
    }
    attribute = <Attribute>[];
    if (json['attribute'] != null) {
      json['attribute'].forEach((v) {
        attribute!.add(new Attribute.fromJson(v));
      });
    }
    price = json['price'] != null ? new Price.fromJson(json['price']) : null;
    totalPieces = json['totalPieces'];
    qty = json['qty'];
    imageUrl = json['imageUrl'];
    skuIds = <SkuIds>[];
    if (json['skuIds'] != null) {
      json['skuIds'].forEach((v) {
        skuIds!.add(new SkuIds.fromJson(v));
      });
    }
    children = <SkuIds>[];
    if (json['children'] != null) {
      json['children'].forEach((v) {
        children!.add(new SkuIds.fromJson(v));
      });
    }
    sTypename = json['__typename'];
  }

  Products.fromRequestJson(dynamic json) {
    sId = json.sId;
    code = json.code;
    productName = json.productName;
    productId = json.productId;
    imageId = json.imageId;
    skuId = json.skuId;
    productDescription = json.productDescription;
    type = json.type;
    isMultiple = json.isMultiple;
    category = <Category>[];
    if (json.category != null) {
      json.category.forEach((v) {
        category!.add(new Category.fromRequestJson(v));
      });
    }
    brand = <Brand>[];
    if (json.brand != null) {
      json.brand.forEach((v) {
        brand!.add(new Brand.fromRequestJson(v));
      });
    }
    attribute = <Attribute>[];
    if (json.attribute != null) {
      json.attribute.forEach((v) {
        attribute!.add(new Attribute.fromRequestJson(v));
      });
    }
    price = json.price != null ? new Price.fromRequestJson(json.price) : null;
    totalPieces = json.totalPieces;
    qty = json.qty;
    imageUrl = json.imageUrl;
    skuIds = <SkuIds>[];
    if (json.skuIds != null) {
      json.skuIds.forEach((v) {
        skuIds!.add(new SkuIds.fromRequestJson(v));
      });
    }
    children = <SkuIds>[];
    if (json.children != null) {
      json.children.forEach((v) {
        children!.add(new SkuIds.fromRequestJson(v));
      });
    }
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['code'] = this.code;
    data['productName'] = this.productName;
    data['productId'] = this.productId;
    data['imageId'] = this.imageId;
    data['skuId'] = this.skuId;
    data['productDescription'] = this.productDescription;
    data['type'] = this.type;
    data['isMultiple'] = this.isMultiple;
    if (this.category != null) {
      data['category'] = this.category!.map((v) => v.toJson()).toList();
    }
    if (this.brand != null) {
      data['brand'] = this.brand!.map((v) => v.toJson()).toList();
    }
    if (this.attribute != null) {
      data['attribute'] = this.attribute!.map((v) => v.toJson()).toList();
    }
    if (this.price != null) {
      data['price'] = this.price!.toJson();
    }
    data['totalPieces'] = this.totalPieces;
    data['qty'] = this.qty;
    data['imageUrl'] = this.imageUrl;
    if (this.skuIds != null) {
      data['skuIds'] = this.skuIds!.map((v) => v.toJson()).toList();
    }
    if (this.children != null) {
      data['children'] = this.children!.map((v) => v.toJson()).toList();
    }
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Category {
  late final String? sId;
  late final String? categoryName;
  late final String? sTypename;

  Category(
      {required this.sId, required this.categoryName, required this.sTypename});

  Category.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    categoryName = json['categoryName'];
    sTypename = json['__typename'];
  }

  Category.fromRequestJson(dynamic json) {
    sId = json.sId;
    categoryName = json.categoryName;
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['categoryName'] = this.categoryName;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Brand {
  late final String? sId;
  late final String? brandName;
  late final String? sTypename;

  Brand({required this.sId, required this.brandName, required this.sTypename});

  Brand.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    brandName = json['brandName'];
    sTypename = json['__typename'];
  }

  Brand.fromRequestJson(dynamic json) {
    sId = json.sId;
    brandName = json.brandName;
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_id'] = this.sId;
    data['brandName'] = this.brandName;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Attribute {
  late final String? fieldName;
  late final String? fieldValue;
  late final String? colorCode;
  late final String? sTypename;

  Attribute(
      {required this.fieldName,
      required this.fieldValue,
      required this.colorCode,
      required this.sTypename});

  Attribute.fromJson(Map<String, dynamic> json) {
    fieldName = json['fieldName'];
    fieldValue = json['fieldValue'];
    colorCode = json['colorCode'];
    sTypename = json['__typename'];
  }

  Attribute.fromRequestJson(dynamic json) {
    fieldName = json.fieldName;
    fieldValue = json.fieldValue;
    colorCode = json.colorCode;
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['fieldName'] = this.fieldName;
    data['fieldValue'] = this.fieldValue;
    data['colorCode'] = this.colorCode;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class Price {
  late final double? mrp;
  late final double? sellingPrice;
  late final double? discount;
  late final double? totalPrice;
  late final double? gstLabelName;
  late final double? withOutGstPrice;
  late final double? sgstLabelName;
  late final double? cgstLabelName;
  late final double? totalSgst;
  late final double? totalCgst;
  late final double? withOutSCGstPrice;
  late final double? totalGst;
  late final String? sTypename;

  Price(
      {required this.mrp,
      required this.sellingPrice,
      required this.discount,
      required this.totalPrice,
      required this.gstLabelName,
      required this.withOutGstPrice,
      required this.sgstLabelName,
      required this.cgstLabelName,
      required this.totalSgst,
      required this.totalCgst,
      required this.withOutSCGstPrice,
      required this.totalGst,
      required this.sTypename});

  Price.fromJson(Map<String, dynamic> json) {
    mrp = makeDouble(json['mrp']);
    sellingPrice = makeDouble(json['sellingPrice']);
    discount = makeDouble(json['discount']);
    totalPrice = makeDouble(json['totalPrice']);
    gstLabelName = makeDouble(json['gstLabelName']);
    withOutGstPrice = makeDouble(json['withOutGstPrice']);
    sgstLabelName = makeDouble(json['sgstLabelName']);
    cgstLabelName = makeDouble(json['cgstLabelName']);
    totalSgst = makeDouble(json['totalSgst']);
    totalCgst = makeDouble(json['totalCgst']);
    withOutSCGstPrice = makeDouble(json['withOutSCGstPrice']);
    totalGst = makeDouble(json['totalGst']);
    sTypename = json['__typename'];
  }

  Price.fromRequestJson(dynamic json) {
    mrp = makeDouble(json.mrp);
    sellingPrice = makeDouble(json.sellingPrice);
    discount = makeDouble(json.discount);
    totalPrice = makeDouble(json.totalPrice);
    gstLabelName = makeDouble(json.gstLabelName);
    withOutGstPrice = makeDouble(json.withOutGstPrice);
    sgstLabelName = makeDouble(json.sgstLabelName);
    cgstLabelName = makeDouble(json.cgstLabelName);
    totalSgst = makeDouble(json.totalSgst);
    totalCgst = makeDouble(json.totalCgst);
    withOutSCGstPrice = makeDouble(json.withOutSCGstPrice);
    totalGst = makeDouble(json.totalGst);
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['mrp'] = this.mrp;
    data['sellingPrice'] = this.sellingPrice;
    data['discount'] = this.discount;
    data['totalPrice'] = this.totalPrice;
    data['gstLabelName'] = this.gstLabelName;
    data['withOutGstPrice'] = this.withOutGstPrice;
    data['sgstLabelName'] = this.sgstLabelName;
    data['cgstLabelName'] = this.cgstLabelName;
    data['totalSgst'] = this.totalSgst;
    data['totalCgst'] = this.totalCgst;
    data['withOutSCGstPrice'] = this.withOutSCGstPrice;
    data['totalGst'] = this.totalGst;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class SkuIds {
  late final String? skuId;
  late final String? imageId;
  late final String? styleCode;
  late final String? sku;
  late final List<Attribute>? attribute;
  late final List<Category>? category;
  late final Brand? brand;
  late final String? productDimension;
  late final String? packingDimension;
  late final num? weight;
  late final String? productId;
  late final String? type;
  late final bool? isMultiple;
  late final String? productName;
  late final String? imageUrl;
  late final String? productDescription;
  late final Price? price;
  late final int? qty;
  late final String? sTypename;

  SkuIds(
      {required this.skuId,
      required this.imageId,
      required this.styleCode,
      required this.sku,
      required this.attribute,
      required this.category,
      required this.brand,
      required this.productDimension,
      required this.packingDimension,
      required this.weight,
      required this.productId,
      required this.type,
      required this.isMultiple,
      required this.productName,
      required this.imageUrl,
      required this.productDescription,
      required this.price,
      required this.qty,
      required this.sTypename});

  SkuIds.fromJson(Map<String, dynamic> json) {
    skuId = json['skuId'];
    imageId = json['imageId'];
    styleCode = json['styleCode'];
    sku = json['sku'];
    if (json['attribute'] != null) {
      attribute = <Attribute>[];
      json['attribute'].forEach((v) {
        attribute!.add(new Attribute.fromJson(v));
      });
    }
    if (json['category'] != null) {
      category = <Category>[];
      json['category'].forEach((v) {
        category!.add(new Category.fromJson(v));
      });
    }
    brand = json['brand'] != null ? new Brand.fromJson(json['brand']) : null;
    productDimension = json['productDimension'];
    packingDimension = json['packingDimension'];
    weight = json['weight'];
    productId = json['productId'];
    type = json['type'];
    isMultiple = json['isMultiple'];
    productName = json['productName'];
    imageUrl = json['imageUrl'];
    productDescription = json['productDescription'];
    price = json['price'] != null ? new Price.fromJson(json['price']) : null;
    qty = json['qty'];
    sTypename = json['__typename'];
  }

  SkuIds.fromRequestJson(dynamic json) {
    skuId = json.skuId;
    imageId = json.imageId;
    styleCode = json.styleCode;
    sku = json.sku;
    if (json.attribute != null) {
      attribute = <Attribute>[];
      json.attribute.forEach((v) {
        attribute!.add(new Attribute.fromRequestJson(v));
      });
    }
    if (json.category != null) {
      category = <Category>[];
      json.category.forEach((v) {
        category!.add(new Category.fromRequestJson(v));
      });
    }
    brand = json.brand != null ? new Brand.fromRequestJson(json.brand) : null;
    productDimension = json.productDimension;
    packingDimension = json.packingDimension;
    weight = json.weight;
    productId = json.productId;
    type = json.type;
    isMultiple = json.isMultiple;
    productName = json.productName;
    imageUrl = json.imageUrl;
    productDescription = json.productDescription;
    price = json.price != null ? new Price.fromRequestJson(json.price) : null;
    qty = json.qty;
    sTypename = json.sTypename;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['skuId'] = this.skuId;
    data['imageId'] = this.imageId;
    data['styleCode'] = this.styleCode;
    data['sku'] = this.sku;
    if (this.attribute != null) {
      data['attribute'] = this.attribute!.map((v) => v.toJson()).toList();
    }
    if (this.category != null) {
      data['category'] = this.category!.map((v) => v.toJson()).toList();
    }
    if (this.brand != null) {
      data['brand'] = this.brand!.toJson();
    }
    data['productDimension'] = this.productDimension;
    data['packingDimension'] = this.packingDimension;
    data['weight'] = this.weight;
    data['productId'] = this.productId;
    data['type'] = this.type;
    data['isMultiple'] = this.isMultiple;
    data['productName'] = this.productName;
    data['imageUrl'] = this.imageUrl;
    data['productDescription'] = this.productDescription;
    if (this.price != null) {
      data['price'] = this.price!.toJson();
    }
    data['qty'] = this.qty;
    data['__typename'] = this.sTypename;
    return data;
  }
}

class SkuPrice {
  late final double? mrp;
  late final double? sellingPrice;
  late final double? discount;
  late final double? rangeDiscount;
  late final double? totalPrice;
  late final double? gstLabelName;
  late final double? withOutGstPrice;
  late final double? sgstLabelName;
  late final double? cgstLabelName;
  late final double? totalSgst;
  late final double? totalCgst;
  late final double? withOutSCGstPrice;
  late final double? totalGst;
  late final String? sTypename;

  SkuPrice(
      {required this.mrp,
      required this.sellingPrice,
      required this.discount,
      required this.rangeDiscount,
      required this.totalPrice,
      required this.gstLabelName,
      required this.withOutGstPrice,
      required this.sgstLabelName,
      required this.cgstLabelName,
      required this.totalSgst,
      required this.totalCgst,
      required this.withOutSCGstPrice,
      required this.totalGst,
      required this.sTypename});

  SkuPrice.fromJson(Map<String, dynamic> json) {
    mrp = makeDouble(json['mrp']);
    sellingPrice = makeDouble(json['sellingPrice']);
    discount = makeDouble(json['discount']);
    rangeDiscount = makeDouble(json['rangeDiscount']);
    totalPrice = makeDouble(json['totalPrice']);
    gstLabelName = makeDouble(json['gstLabelName']);
    withOutGstPrice = makeDouble(json['withOutGstPrice']);
    sgstLabelName = makeDouble(json['sgstLabelName']);
    cgstLabelName = makeDouble(json['cgstLabelName']);
    totalSgst = makeDouble(json['totalSgst']);
    totalCgst = makeDouble(json['totalCgst']);
    withOutSCGstPrice = makeDouble(json['withOutSCGstPrice']);
    totalGst = makeDouble(json['totalGst']);
    sTypename = json['__typename'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['mrp'] = this.mrp;
    data['sellingPrice'] = this.sellingPrice;
    data['discount'] = this.discount;
    data['rangeDiscount'] = this.rangeDiscount;
    data['totalPrice'] = this.totalPrice;
    data['gstLabelName'] = this.gstLabelName;
    data['withOutGstPrice'] = this.withOutGstPrice;
    data['sgstLabelName'] = this.sgstLabelName;
    data['cgstLabelName'] = this.cgstLabelName;
    data['totalSgst'] = this.totalSgst;
    data['totalCgst'] = this.totalCgst;
    data['withOutSCGstPrice'] = this.withOutSCGstPrice;
    data['totalGst'] = this.totalGst;
    data['__typename'] = this.sTypename;
    return data;
  }
}

double makeDouble(num? value) {
  return value != null ? value.toDouble() : 0.0;
  // return (field ?? 0).toDouble();
}
