PreferenceSetting preferenceSettingFromJson(dynamic str) =>
    (PreferenceSetting.fromJson(str));

class PreferenceSetting {
  late final String? sId;
  late final OrderPreferenceSetting? order;
  late final LoginPreferenceSetting? login;
  late final PaymentPreferenceSetting? payment;
  late final LogisticPreferenceSetting? logistic;
  PreferenceSetting(
      {required this.sId,
      required this.order,
      required this.login,
      required this.payment,
      this.logistic});
  PreferenceSetting.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    order = OrderPreferenceSetting.fromJson(json['order']);
    login = LoginPreferenceSetting.fromJson(json['login']);
    payment = PaymentPreferenceSetting.fromJson(json['payment']);
    logistic = LogisticPreferenceSetting.fromJson(json['logistic']);
  }
}

class OrderPreferenceSetting {
  late final bool? enableDirectPayment;
  late final bool? enableReseller;
  OrderPreferenceSetting(
      {required this.enableDirectPayment, required this.enableReseller});

  OrderPreferenceSetting.fromJson(Map<String, dynamic> json) {
    enableDirectPayment = json['enableDirectPayment'];
    enableReseller = json['enableReseller'];
  }
}

class LoginPreferenceSetting {
  late final bool smsOtp;
  late final bool emailOtp;
  late final bool country;
  LoginPreferenceSetting(
      {required this.smsOtp, required this.emailOtp, required this.country});

  LoginPreferenceSetting.fromJson(Map<String, dynamic> json) {
    smsOtp = json['smsOtp'];
    emailOtp = json['emailOtp'];
    country = json['country'];
  }
}

class PaymentPreferenceSetting {
  late final String paymentGateway;
  PaymentPreferenceSetting({required this.paymentGateway});
  PaymentPreferenceSetting.fromJson(Map<String, dynamic> json) {
    paymentGateway = json['paymentGateway'];
  }
}

class LogisticPreferenceSetting {
  late final String shipmentProvider;
  LogisticPreferenceSetting({required this.shipmentProvider});
  LogisticPreferenceSetting.fromJson(Map<String, dynamic> json) {
    shipmentProvider = json['shipmentProvider'];
  }
}
