import 'package:b2b_graphql_package/GraphQLConfiguration.dart';
import 'package:b2b_graphql_package/modules/preference_setting/preference_setting_model.dart';
import 'package:graphql_flutter/graphql_flutter.dart';

class PreferenceSettingRepo {
  var graphQLConfiguration;
  var preferenceSetting;

  PreferenceSettingRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }

  Future getPreferenceSetting() async {
    GraphQLClient _clinet = graphQLConfiguration.clientToQuery();

    String preferenceSettingQuery = """
         query getPreferenceSetting {
    getPreferenceSetting {
            _id
            order {
                enableDirectPayment
                enableReseller
            }
            login {
              smsOtp
              emailOtp
              country
            }
            payment {
                paymentGateway
            }
            logistic {
                shipmentProvider
            }
            }
}
""";
    QueryResult result = await _clinet.query(QueryOptions(
        document: gql(preferenceSettingQuery),
        fetchPolicy: FetchPolicy.networkOnly));

    if (!result.hasException) {
      var data = result.data!['getPreferenceSetting'];
      print(data);
      if (data != null) {
        preferenceSetting = preferenceSettingFromJson(data);
      }
    }
    return preferenceSetting;
  }
}
